module:	dylan-user

// testing a class defined within a module.

define module Test
	use dylan, export: all;
		
	export <test>, main;
end module Test;

define abstract class <abstract-test> (<object>) end class;

define class <test> (<abstract-test>)
	slot needs-initializing :: <integer>,
      required-init-keyword: ni:;
end class;

define method initialize (self :: <test>, #key ni (10))
	next-method();
	self.needs-initializing := ni;
end method;

define method main ()
	print(make(<test>, ni: 20));
end method;

main();
